#include <iostream>
#include <string>
#include <vector>
#include "Person.h"
using namespace std;

Person::~Person()
{
    // Recursively delete the children.
    for (Person *child : children) delete child;
    cout << "deleted " << name << endl;
}

void Person::procreate(Person *child)
{
    children.push_back(child);
    child->parent = this;
}

void Person::print() const
{
    if (parent != nullptr) cout << "+---";

    // Print the name and the spouse's name, if any.
    cout << name;
    if (spouse_name.length() > 0) cout << " (" << spouse_name << ")";
    cout << endl;

    // Print the children, if any.
    for (Person *child : children)
    {
        // Print any ancestors' bars.
        print_bar(); cout << "|" << endl;
        print_bar();

        // Recursively print a child.
        child->print();
    }
}

void Person::print_bar() const
{
    if (parent != nullptr)
    {
        // Recursively print my parent's bar.
        parent->print_bar();

        // Am I my parent's last child?
        if (this == parent->children.back()) cout << "    ";  // yes
        else                                 cout << "|   ";  // no
    }
}
